'***************************************
'***************************************
'* MMBasic 4.5 for Maximite/Duinomite
'* twofingers at TBS 08-2014
'* No warranty, provided at your own risk.
'*       This code may be freely 
'*     distributed without charge 
'*
'*          John Conway's
'*      "Game of Life" v1.01
'*
'*   a code example/benchmark
'***************************************
'***************************************

Cls
        '** plz edit field dimensions **
	'*** smaller field = faster ****
C_x =45 ' entire field width w. border
C_y =40 ' entire field height w. border
        '*******************************

C_x1=C_x -1
C_y1=C_y -1

L$=" ":X$="x"
Option base 0
Dim w$(C_x,C_y,2) length 1
Dim a1(2),a2(2)


t=0
clearworld

'***** Plz select:
Demo1
'***** or
'Demo2

gen=0:Timer=0:z=0

Line (1*6,1*8)-(C_x*6+6,C_y*8+12),1,BF
a1(0)=2:a2(0)=C_x1
a1(1)=C_x1:a2(1)=2
Font #2,,1:fontbreite=12
titel$="The Game of LIFE"
Print @((C_x*6/2)-(Len(titel$)/2*fontbreite),50) Titel$

Font #1

wait "Press any key!"

'********** Mainloop ***************
Do

  t1=Abs(t=0)
  println(5,C_y+3,Str$(t)+" "+Str$(t1)+" gen:"+Str$(gen)+" tm:"+Str$(Timer))

  Timer=0
For x=a1(t) To a2(t) Step 1-t*2
Line (x*6,1*8+8)-(x*6+5,C_y*8+4),0,BF
For y=2 To C_y1
c=n(x,y)
a$=w$(x,y,t)
If a$<>X$ Then
If c=3 Then w$(x,y,t1)=X$
Else
plotxy (x,y)
If c=2 Or c=3 Then w$(x,y,t1)=X$
EndIf
Next y
Next x

  clearworld

  t=not t '0,1,0,1,0,...
  gen=gen+1
  z=z+Timer
  println(25,C_y+3,"avg:"+Str$(Int(z*10/gen)/10))

Loop
'********** END Mainloop *************


'* counting neighbors
Function n (x,y)
  If w$(x-1,y,t)=X$ Then n=n+1
  If w$(x+1,y,t)=X$ Then n=n+1
  If w$(x-1,y-1,t)=X$ Then n=n+1
  If w$(x,y-1,t)=X$ Then n=n+1
  If w$(x+1,y-1,t)=X$ Then n=n+1
  If w$(x-1,y+1,t)=X$ Then n=n+1
  If w$(x,y+1,t)=X$ Then n=n+1
  If w$(x+1,y+1,t)=X$ Then n=n+1
End Function


Sub clearworld
  For x = 2 To C_x1
    For y = 2 To C_y1
      w$(x,y,t)=L$
    Next
  Next
End Sub


' **** Println (col, row, string$) ****
Sub println (x,y,s$)
  Print @(x*6,y*8) s$
End Sub


Sub plotxy (x,y)
  Circle (x*6+3,y*8+4),2,F
End Sub


' **** initial filling ****
Sub Demo1
  population_density=0.20
  For x = 2 To C_x1
    For y = 2 To C_y1
      r=Rnd(randomize) 
      If r<population_density Then 
        w$(x,y,t)=X$
      EndIf
    Next
  Next
End Sub


Sub Demo2
       ' Pentadecathlon, a period 15 oscillator
       ' (here you can create your own pattern) 

       '1   2   3   4   5   6   7   8   9   10  11
  Data "x","x","x","x","x","x","x","x"
  Data "x"," ","x","x","x","x"," ","x"
  Data "x","x","x","x","x","x","x","x"

  For y = 10 To 12
    For x = 9 To 16
      Read w$(x,y,t)
    Next
  Next
End Sub


' **** wait or wait + text (center and bottom of screen) ****
Sub wait prompt$
  If prompt$<>"" Then Print @((MM.HRes-Len(prompt$))/2,MM.VRes-12) prompt$
  Do While Inkey$="":Loop
  If prompt$<>"" Then Print @((MM.HRes-Len(prompt$))/2,MM.VRes-12) String$(Len(prompt$)," ")
End Sub